oops - uses new lst parsing in subdir too
[sliceimage.git] / build.sh
index 58f8bcb..fd6757c 100755 (executable)
--- a/build.sh
+++ b/build.sh
@@ -1,11 +1,18 @@
 #!/bin/bash
 #
-# Builds VServer reference image
+# Builds all reference image for vservers.  To optimize for space it
+# will only build a complete base vserver reference image and then
+# builds "stub" images that are just contain the additional files
+# and/or changes for a given reference image.  This is done to shrink
+# the RPM itself.  These will be pieced back together with the base
+# vserver reference image by an init script that is installed on the
+# node.
 #
 # Mark Huang <mlhuang@cs.princeton.edu>
-# Copyright (C) 2004-2006 The Trustees of Princeton University
+# Marc E. Fiuczynski <mef@cs.princeton.edu>
+# Copyright (C) 2004-2007 The Trustees of Princeton University
 #
-# $Id: build.sh,v 1.4 2006/03/21 14:57:29 mlhuang Exp $
+# $Id: build.sh,v 1.20 2007/09/06 20:41:23 faiyaza Exp $
 #
 
 PATH=/sbin:/bin:/usr/sbin:/usr/bin
@@ -17,48 +24,99 @@ if [ -d ../build ] ; then
     PATH=$PATH:../build
     srcdir=..
 else
-    echo "Error: Could not find sources in either . or .."
+    echo "Error: Could not find $(cd .. && pwd -P)/build/"
     exit 1
 fi
 
 export PATH
 
-# Release and architecture to install
-releasever=2
-basearch=i386
+# build.common comes from the build module
+. build.common
 
-usage()
-{
-    echo "Usage: build.sh [OPTION]..."
-    echo "     -r release      Fedora release number (default: $releasever)"
-    echo "     -a arch         Fedora architecture (default: $basearch)"
-    echo "     -h              This message"
-    exit 1
-}
-
-# Get options
-while getopts "r:a:h" opt ; do
-    case $opt in
-       r)
-           releasever=$OPTARG
-           ;;
-       a)
-           basearch=$OPTARG
-           ;;
-       h|*)
-           usage
-           ;;
-    esac
-done
+pl_process_fedora_options $@
+shiftcount=$?
+shift $shiftcount
+
+# pldistro expected as $1 - defaults to planetlab
+pldistro=planetlab
+[ -n "$@" ] && pldistro=$1
+
+# Do not tolerate errors
+set -e
+
+# Path's to the vserver references images and stubs
+vrefdir=$PWD/vservers/.vref
+vstubdir=$PWD/vservers/.vstub
+
+# XXX: The vserver reference name should be passed in as an argument
+# rather than being hardcoded.
+vrefname=default
+
+# Make /vservers and default vserver reference image
+vref=${vrefdir}/${vrefname}
+install -d -m 755 ${vref}
+
+# "Parse" out the packages and groups for mkfedora
+lst="${pldistro}-vserver.lst"
+options="$(pl_getPackagesOptions2 ${pl_DISTRO_NAME} $lst) $(pl_getGroupsOptions ${pl_DISTRO_NAME} $lst)"
+
+# Populate a minimal /dev in the reference image
+pl_makedevs ${vref}
+
+# Populate image with vserver-reference packages
+pl_setup_chroot ${vref} ${options} -k
 
-# Make /vservers
-vroot=$PWD/vservers/vserver-reference
-install -d -m 755 $vroot
+for systemvserver in ${pldistro}-vservers/*.lst ; do
+    NAME=$(basename $systemvserver .lst)
 
-# Install vserver-reference system
-mkfedora -v -r $releasever -a $basearch -g VServer $vroot
+    echo "--------START BUILDING system vserver ${NAME}: $(date)"
+
+    # "Parse" out the packages and groups for yum
+    systempackages=$(pl_getPackages2 ${pl_DISTRO_NAME} $systemvserver)
+    systemgroups=$(pl_getGroups2 ${pl_DISTRO_NAME} $systemvserver)
+
+    vdir=${vstubdir}/${NAME}
+    rm -rf ${vdir}/*
+    install -d -m 755 ${vdir}
+
+    # Clone the base vserver reference to the system vserver reference
+    (cd ${vref} && find . | cpio -m -d -u -p ${vdir})
+    rm -f ${vdir}/var/lib/rpm/__db*
+
+    # Communicate to the initialization script from which vref this stub was cloned
+    echo ${vrefname} > ${vdir}.cloned
+
+    # Install the system vserver specific packages
+    [ -n "$systempackages" ] && yum -c ${vdir}/etc/yum.conf --installroot=${vdir} -y install $systempackages
+    [ -n "$systemgroups" ] && yum -c ${vdir}/etc/yum.conf --installroot=${vdir} -y groupinstall $systemgroups
+
+    # Create a copy of the system vserver w/o the vserver reference files and make it smaller. 
+    # This is a three step process:
+
+    # step 1: clean out yum cache to reduce space requirements
+    yum -c ${vdir}/etc/yum.conf --installroot=${vdir} -y clean all
+
+    # step 2: figure out the new/changed files in ${vdir} vs. ${vref} and compute ${vdir}.changes
+    rsync -anv ${vdir}/ ${vref}/ > ${vdir}.changes
+    linecount=$(wc -l ${vdir}.changes | awk ' { print $1 } ')
+    let headcount=$linecount-3
+    let tailcount=$headcount-1
+    # get rid of the last 3 lines of the rsync output
+    head -${headcount} ${vdir}.changes > ${vdir}.changes.1
+    # get rid of the first line of the rsync output
+    tail -${tailcount} ${vdir}.changes.1 > ${vdir}.changes.2
+    # post process rsync output to get rid of symbolic link embellish output
+    awk ' { print $1 } ' ${vdir}.changes.2 > ${vdir}.changes
+    rm -f ${vdir}.changes.*
+
+    # step 3: create the ${vdir} with just the list given in ${vdir}.changes 
+    install -d -m 755 ${vdir}-tmp/
+    rm -rf ${vdir}-tmp/*
+    (cd ${vdir} && cpio -m -d -u -p ${vdir}-tmp < ${vdir}.changes)
+    rm -rf ${vdir}
+    rm -f  ${vdir}.changes
+    mv ${vdir}-tmp ${vdir}
+    echo "--------DONE BUILDING system vserver ${NAME}: $(date)"
+done
 
-# This tells the Boot Manager that it is okay to update
-# /etc/resolv.conf and /etc/hosts whenever the network configuration
-# changes. Users are free to delete this file.
-touch $vroot/etc/AUTO_UPDATE_NET_FILES
+exit 0